/**this file adds information on teacher turnover to the data sets for regressions on teacher
characteristics**/

set more off
log using ${rivkin_home}simba_e/Texas/quality/RESULTS/addtturn.log,replace

use ${rivkin_home}simba_e/texdata/Texas/teacher/turnov

local year=94
while `year'<=97 {

	local pyr= `year'-1

	local grade=4
	while `grade'<=7 {

		gen pmsa`grade'`year'=.

		replace pmsa`grade'`year'=pmsa`year'`pyr' if grade==`grade' & pmsa`year'`pyr'>=0 & pmsa`year'`pyr'<=1

		local grade = `grade'+1
		}

	local year = `year' + 1
	}

keep campus pmsa495 pmsa594 pmsa595 pmsa596 pmsa695 pmsa696 pmsa697 pmsa796 pmsa797
collapse pmsa495 pmsa594 pmsa595 pmsa596 pmsa695 pmsa696 pmsa697 pmsa796 pmsa797,by(campus)

rename campus camp

di "reshape data"
reshape groups year 495 594 595 596 695 696 697 796 797
reshape vars  pmsa
reshape cons camp
reshape query  
reshape long

sort camp year

save ${rivkin_home}simba_e/texdata/Texas/teacher/ddturn,replace
sum

clear
