/**this file creates a file to run fixed effects regressions.**/

set more off
cap log close


log using ${rivkin_home}simba_e/Texas/quality/RESULTS/corsm.log,replace

tempfile temp594 temp595 temp796 temp695 temp696 temp797

di "creating files for grade 5 data"
local daloop = 594
while `daloop'<=595 {

     di "creating file for `daloop'"
     use rivid camp`daloop' spec`daloop' bil`daloop' smgai`daloop' using ${rivkin_home}simba_e/texdata/Texas/quality/mstea`daloop'

     rename camp`daloop' camp
     drop if spec`daloop'==1 | bil`daloop'==1

     collapse smgai`daloop' (count) num`daloop'=smgai`daloop',by(camp)
     sort camp
     save `temp`daloop'',replace

     local daloop = `daloop' + 1

     }


di "creating files for grade 6 data"
local daloop = 695
while `daloop'<=696 {

     di "creating file for `daloop'"
     use rivid camp`daloop' spec`daloop' bil`daloop' smgai`daloop' using ${rivkin_home}simba_e/texdata/Texas/quality/mstea`daloop'

     rename camp`daloop' camp
     drop if spec`daloop'==1 | bil`daloop'==1

     collapse smgai`daloop' (count) num`daloop'=smgai`daloop',by(camp)
     sort camp
     save `temp`daloop'',replace

     local daloop = `daloop' + 1

     }

di "creating files for grade 7 data"
local daloop = 796
while `daloop'<=797 {

     di "creating file for `daloop'"
     use rivid camp`daloop' spec`daloop' bil`daloop' smgai`daloop' using ${rivkin_home}simba_e/texdata/Texas/quality/mstea`daloop'

     rename camp`daloop' camp
     drop if spec`daloop'==1 | bil`daloop'==1

     collapse smgai`daloop' (count) num`daloop'=smgai`daloop',by(camp)
     sort camp
     save `temp`daloop'',replace

     local daloop = `daloop' + 1

     }

di "merging data"
use `temp594'

merge camp using `temp595'
tab _m
drop _m
sort camp

merge camp using `temp696'
tab _m
drop _m
sort camp

merge camp using `temp695'
tab _m
drop _m
sort camp

merge camp using `temp796'
tab _m
drop _m
sort camp

merge camp using `temp797'
tab _m
drop _m
sort camp

di "generate weights for weighted correlations"
gen wgt55=(num594+num595)/2
gen wgt66=(num695+num696)/2
gen wgt77=(num796+num797)/2
gen wgt56=(num595+num695)/2
gen wgt67=(num696+num796)/2

pwcorr smgai595 smgai695, sig
pwcorr smgai696 smgai796, sig
pwcorr smgai595 smgai594, sig
pwcorr smgai696 smgai695, sig
pwcorr smgai797 smgai796, sig

pwcorr smgai595 smgai695 [aweight=wgt56], sig
pwcorr smgai696 smgai796 [aweight=wgt67], sig
pwcorr smgai595 smgai594 [aweight=wgt55], sig
pwcorr smgai696 smgai695 [aweight=wgt66], sig
pwcorr smgai797 smgai796 [aweight=wgt77], sig

regress smgai595 smgai695 [aweight=wgt56]
regress smgai696 smgai796 [aweight=wgt67]
regress smgai595 smgai594 [aweight=wgt55]
regress smgai696 smgai695 [aweight=wgt66]
regress smgai797 smgai796 [aweight=wgt77]

