/**this file creates a file to run fixed effects regressions.**/

set more off
cap log close


log using ${rivkin_home}simba_e/Texas/quality/RESULTS/corsr.log,replace

tempfile temp594 temp595 temp796 temp695 temp696 temp797

di "creating files for grade 5 data"
local daloop = 594
while `daloop'<=595 {

     di "creating file for `daloop'"
     use rivid camp`daloop' spec`daloop' bil`daloop' srgai`daloop' using ${rivkin_home}simba_e/texdata/Texas/quality/rstea`daloop'

     rename camp`daloop' camp
     drop if spec`daloop'==1 | bil`daloop'==1

     collapse srgai`daloop' (count) num`daloop'=srgai`daloop',by(camp)
     sort camp
     save `temp`daloop'',replace

     local daloop = `daloop' + 1

     }


di "creating files for grade 6 data"
local daloop = 695
while `daloop'<=696 {

     di "creating file for `daloop'"
     use rivid camp`daloop' camp`daloop' spec`daloop' bil`daloop' srgai`daloop' using ${rivkin_home}simba_e/texdata/Texas/quality/rstea`daloop'

     rename camp`daloop' camp
     drop if spec`daloop'==1 | bil`daloop'==1

     collapse srgai`daloop' (count) num`daloop'=srgai`daloop',by(camp)
     sort camp
     save `temp`daloop'',replace

     local daloop = `daloop' + 1

     }


di "creating files for grade 7 data"
local daloop = 796
while `daloop'<=797 {

     di "creating file for `daloop'"
     use rivid camp`daloop' spec`daloop' bil`daloop' srgai`daloop' using /mnt/data//tsp/users/rivkin/simba_e/texdata/Texas/quality/rstea`daloop'

     rename camp`daloop' camp
     drop if spec`daloop'==1 | bil`daloop'==1

     collapse srgai`daloop' (count) num`daloop'=srgai`daloop',by(camp)
     sort camp
     save `temp`daloop'',replace

     local daloop = `daloop' + 1

     }

di "merging data"
use `temp594'

merge camp using `temp595'
tab _m
drop _m
sort camp

merge camp using `temp696'
tab _m
drop _m
sort camp

merge camp using `temp695'
tab _m
drop _m
sort camp

merge camp using `temp796'
tab _m
drop _m
sort camp

merge camp using `temp797'
tab _m
drop _m
sort camp

di "generate weights for weighted correlations"
gen wgt55=(num594+num595)/2
gen wgt66=(num695+num696)/2
gen wgt77=(num796+num797)/2
gen wgt56=(num595+num695)/2
gen wgt67=(num696+num796)/2

pwcorr srgai595 srgai695, sig
pwcorr srgai696 srgai796, sig
pwcorr srgai595 srgai594, sig
pwcorr srgai696 srgai695, sig
pwcorr srgai797 srgai796, sig

pwcorr srgai595 srgai695 [aweight=wgt56], sig
pwcorr srgai696 srgai796 [aweight=wgt67], sig
pwcorr srgai595 srgai594 [aweight=wgt55], sig
pwcorr srgai696 srgai695 [aweight=wgt66], sig
pwcorr srgai797 srgai796 [aweight=wgt77], sig

regress srgai595 srgai695 [aweight=wgt56]
regress srgai696 srgai796 [aweight=wgt67]
regress srgai595 srgai594 [aweight=wgt55]
regress srgai696 srgai695 [aweight=wgt66]
regress srgai797 srgai796 [aweight=wgt77]
