 /**this file regresses the squared deviation in gains between the two classes on teacher turnover.**/

cap log close
log using ${rivkin_home}simba_e/Texas/quality/RESULTS/covregss.log,replace

tempfile tempdat tempnum tempdr tempnr
set more off

di "math"
di "all stayers"
use ${rivkin_home}simba_e/texdata/Texas/quality/coldatsm
tab grade7
sort grade7
by grade7: sum

keep if covdsv~=. & pmsaf~=. & nunpf~=. & nunsf~=. & numt==1 & numtf==1
tab grade7

sort camp year
save `tempdat'

di "keep only schools with 2 years of data"
quietly by camp year: keep if _n==1
sort camp year
quietly by camp: gen num=_N
tab num

keep if num==2
keep camp year num
sort camp year
save `tempnum'

merge camp year using `tempdat'
tab _m
keep if _m==3
drop _m


di "create inverse of enrol"
gen ienrol=1/avenrol

di "summarize percent same"
sum pmsa, detail

di "correlate turnover with number of teachers"
cor pmsa numt
cor pmsaf numtf

di "generate % different divided by number of teachers"
gen pdif=(1-pmsa)/numt
gen pdiff=(1-pmsaf)/numtf

sum n*

di "generate interaction with grade7"
gen pdif7=pdif*grade7
gen pdiff7=pdiff*grade7

di "MATH TEACHERS"

di "no fixed effects"
regress covsmv pdif nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff nunpf nunsf year594 ienrol,absorb(camp)

di "include percent gain experience"
di "no fixed effects"
regress covsmv pdif nunp nuns pmgx year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff nunpf nunsf pmgxf year594 ienrol grade7

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff nunpf nunsf pmgxf year594 ienrol,absorb(camp)

di "include change in zero yrs experience and percent gain experience data"

di "no fixed effects"
regress covsmv pdif nunp nuns pmgx mchz year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff nunpf nunsf pmgxf mchzf year594 ienrol grade7

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff nunpf nunsf pmgxf mchzf year594 ienrol,absorb(camp)

di "grade 7 interactions"
regress covsmv pdif pdif7 nunp nuns year594 ienrol grade7
regress covdsv pdiff pdiff7 nunpf nunsf year594 grade7 ienrol
areg covdsv pdiff pdiff7 nunpf nunsf year594 ienrol,absorb(camp)

clear

di "reading"
di "all stayers"
use ${rivkin_home}simba_e/texdata/Texas/quality/coldatsr
tab grade7
sort grade7
by grade7: sum

keep if covdsv~=. & pesaf~=. & nunpf~=. & nunsf~=. & nuet==1 & nuetf==1

tab grade7

sort camp year
save `tempdr'

di "keep only schools with 2 years of data"
quietly by camp year: keep if _n==1
sort camp year
quietly by camp: gen num=_N
tab num

keep if num==2
keep camp year num
sort camp year
save `tempnr'

merge camp year using `tempdr'
tab _m
keep if _m==3
drop _m


di "create inverse of enrol"
gen ienrol=1/avenrol

di "summarize percent same"
sum pesa, detail

di "correlate turnover with number of teachers"
cor pesa numt
cor pesaf numtf

di "generate % different divided by number of teachers"
gen pdif=(1-pesa)/nuet
gen pdiff=(1-pesaf)/nuetf

sum n*


di "generate interaction with grade7"
gen pdif7=pdif*grade7
gen pdiff7=pdiff*grade7

di "ENGLISH TEACHERS"
di "no fixed effects"
regress covsmv pdif nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff nunpf nunsf year594 ienrol,absorb(camp)

di "include percent gain experience"
di "no fixed effects"
regress covsmv pdif nunp nuns pegx year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff nunpf nunsf pegxf year594 ienrol grade7

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff nunpf nunsf pegxf year594 ienrol,absorb(camp)

di "include change in zero yrs experience and percent gain experience data"

di "no fixed effects"
regress covsmv pdif nunp nuns pegx echz year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff nunpf nunsf pegxf echzf year594 ienrol grade7

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff nunpf nunsf pegxf echzf year594 ienrol,absorb(camp)

di "grade 7 interactions"
regress covsmv pdif pdif7 nunp nuns year594 ienrol grade7
regress covdsv pdiff pdiff7 nunpf nunsf year594 grade7 ienrol
areg covdsv pdiff pdiff7 nunpf nunsf year594 ienrol,absorb(camp)
