 /**this file regresses the squared deviation in gains between the two classes on teacher turnover.**/

cap log close
log using ${rivkin_home}simba_e/Texas/quality/RESULTS/covregsu.log,replace

tempfile tempdat tempnum
set more off

di "math"
di "all stayers"
use ${rivkin_home}simba_e/texdata/Texas/quality/coldatsm

egen grade7m=max(grade7),by(camp)
replace grade7=grade7m if grade7==.

keep if covdsv~=. & pmsaf~=. & subf==1 & pesaf~=. & nunpf~=. & avenrol~=. & avenrol~=0 & year594~=. & grade7~=. /*
*/ & pmgxf~=. & mchzf~=.

di "create inverse of enrol"
gen ienrol=1/avenrol

di "generate % different divided by number of teachers"
gen pdif=(1-pmsa)/numt
gen pdiff=(1-pmsaf)/numtf

di "examine students per teacher"
gen stperte=avenrol/numt
sum stperte,detail

di "MATH TEACHERS AND ENGLISH TEACHERS"
di "with other subject"
di "no fixed effects"
regress covsmv pdif pesa nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff pesaf nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff pesaf nunpf nunsf year594 ienrol ,absorb(camp)

di "without other subject"
di "no fixed effects"
regress covsmv pdif nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff nunpf nunsf year594 ienrol ,absorb(camp)

di "with other subject"
di "no fixed effects"
regress covsmv pdif mchz pesa nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff mchzf pesaf nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff mchzf pesaf nunpf nunsf year594 ienrol ,absorb(camp)

di "without other subject"
di "no fixed effects"
regress covsmv pdif mchz nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff mchzf nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff mchzf nunpf nunsf year594 ienrol ,absorb(camp)

sum smgai,detail
clear

di "READING"
di "all stayers"
use ${rivkin_home}simba_e/texdata/Texas/quality/coldatsr

egen grade7m=max(grade7),by(camp)
replace grade7=grade7m if grade7==.

keep if covdsv~=. & pmsaf~=. & subf==1 & pesaf~=. & nunpf~=. & avenrol~=. & avenrol~=0 & year594~=. & grade7~=. /*
*/ & echzf~=. & pegxf~=.
di "create inverse of enrol"
gen ienrol=1/avenrol

di "generate % different divided by number of teachers"
gen pdif=(1-pesa)/nuet
gen pdiff=(1-pesaf)/nuetf

di "examine students per teacher"
gen stperte=avenrol/nuet
sum stperte,detail

di "MATH TEACHERS AND ENGLISH TEACHERS"
di "with other subject"
di "no fixed effects"
regress covsmv pdif pmsa nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff pmsaf nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff pmsaf nunpf nunsf year594 ienrol ,absorb(camp)

di "without other subject"
regress covsmv pdif nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff nunpf nunsf year594 ienrol ,absorb(camp)

di "with other subject"
di "no fixed effects"
regress covsmv pdif echz pmsa nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff echzf pmsaf nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff echzf pmsaf nunpf nunsf year594 ienrol ,absorb(camp)

di "without other subject"
regress covsmv pdif echz nunp nuns year594 ienrol grade7

di "school fixed effects, 6th gain - 5th gain"
regress covdsv pdiff echzf nunpf nunsf year594 ienrol grade7 

di "school by grade fixed effects,dif in 6th gain - 5th gain between cohorts "
areg covdsv pdiff echzf nunpf nunsf year594 ienrol ,absorb(camp)



sum srgai,detail

