/**this file creates a file to run school fixed effect regressions for schools with no new teacher turnover.**/

set more off
cap log close

set memory 5g
set maxvar 10000
set matsize 10000

log using ${rivkin_home}simba_e/Texas/quality/RESULTS/altexpreg3.log,replace

tempfile tempdat tempdr temps tempsr
/*
use ${rivkin_home}simba_e/texdata/Texas/quality/studwk
sort rivid

di "merge in data on new teacher transitions"
sort camp year
merge camp year using ${rivkin_home}simba_e/texdata/Texas/teacher/turnov3
tab _m
drop _m

sort camp
save `temps'

quietly by camp: keep if _n==1
keep camp

di "create campus id for schools
gen int campid=_n

di "merge with student level data"
sort camp
merge camp using `temps'
tab _m
drop _m

save `tempdat'
/*
drop if drop==1
*/
local year year594 year595 year596 year695 year696 year697 year796 year797
/*
sum 

di "student and school fixed effect regression, grade interactions"
felsdvreg smgai disad same pmas pzex poex ptex ptfex stud4 stud5 stud6 stud7 `year', /*
*/ ivar(rivid) jvar(campid) feff(feffcy) peff(peffcy) xb(xb) res(res) mover(mover) group(group) mnum(mnum)/*
*/ pobs(pobs) robust cluster(camp)

drop xb* res* mover group mnum pobs

outreg disad same pmas pzex poex ptex ptfex stud4 stud5 stud6 stud7 using /*
*/ ${rivkin_home}simba_e/Texas/quality/RESULTS/expregsm, se nocons noparen nor2 noaster bdec(4) nonotes replace


clear
*/
use `tempdat'

drop if dropa==1

di "student and school fixed effect regression, grade interactions"
felsdvreg smgai disad same pmas pzex poex ptex ptfex stud4 stud5 stud6 stud7 `year', /*
*/ ivar(rivid) jvar(campid) feff(feffcy) peff(peffcy) xb(xb) res(res) mover(mover) group(group) mnum(mnum)/*
*/ pobs(pobs) robust cluster(camp)

drop xb* res* mover group mnum pobs
/*
outreg disad same pmas pzex poex ptex ptfex stud4 stud5 stud6 stud7 using /*
*/ ${rivkin_home}simba_e/Texas/quality/RESULTS/expregsm, se nocons noparen nor2 noaster bdec(4) nonotes append
*/
clear
*/
use ${rivkin_home}simba_e/texdata/Texas/quality/studwkr
sort rivid

di "merge in data on new teacher transitions"
sort camp year
merge camp year using ${rivkin_home}simba_e/texdata/Texas/teacher/turnov3
tab _m
drop _m

sort camp
save `tempsr'

quietly by camp: keep if _n==1
keep camp

di "create campus id for schools"
gen int campid=_n

di "merge with student level data"
sort camp
merge camp using `tempsr'
tab _m
drop _m

save `tempdr'

drop if drop==1

di "student and school fixed effect regression, grade interactions"
felsdvreg srgai disad same pmas pzex poex ptex ptfex stud4 stud5 stud6 stud7 `year', /*
*/ ivar(rivid) jvar(campid) feff(feffcy) peff(peffcy) xb(xb) res(res) mover(mover) group(group) mnum(mnum)/*
*/ pobs(pobs) robust cluster(camp)

drop xb* res* mover group mnum pobs
/*
outreg disad same pmas pzex poex ptex ptfex stud4 stud5 stud6 stud7 using /*
*/ ${rivkin_home}simba_e/Texas/quality/RESULTS/expregsr, se nocons noparen nor2 noaster bdec(4) nonotes replace
*/
clear

use `tempdr'

drop if dropa==1

di "student and school fixed effect regression, grade interactions"
felsdvreg srgai disad same pmas pzex poex ptex ptfex stud4 stud5 stud6 stud7 `year', /*
*/ ivar(rivid) jvar(campid) feff(feffcy) peff(peffcy) xb(xb) res(res) mover(mover) group(group) mnum(mnum)/*
*/ pobs(pobs) robust cluster(camp)

drop xb* res* mover group mnum pobs
/*
outreg disad same pmas pzex poex ptex ptfex stud4 stud5 stud6 stud7 using /*
*/ ${rivkin_home}simba_e/Texas/quality/RESULTS/expregsr, se nocons noparen nor2 noaster bdec(4) nonotes append
*/
clear
