set more off

log using ${rivkin_home}simba_e/Texas/quality/RESULTS/fixexp.log,replace

/**this file identifies and fixes inconsistent information on teacher experience. The fix is dropped if it leads to experience values less than 0 or there is inconsistent info that cannot be resolved.**/

use ${rivkin_home}simba_e/texdata/Texas/teacher/masttea193198

gen byte expbad=0
replace expbad=1 if exper94-exper93~=1 & exper93~=. & exper94~=.
replace expbad=1 if exper95-exper94~=1 & exper94~=. & exper95~=.
replace expbad=1 if exper96-exper95~=1 & exper95~=. & exper96~=.
replace expbad=1 if exper97-exper96~=1 & exper96~=. & exper97~=.
replace expbad=1 if exper98-exper97~=1 & exper97~=. & exper98~=.
#delimit ;

replace expbad=1 if exper98-exper96~=2 & exper96~=. & exper98~=. & (exper97~=. |
(exper97==. & exper98-exper96~=1));

replace expbad=1 if exper97-exper95~=2 & exper95~=. & exper97~=. & (exper96~=. |
(exper96==. & exper97-exper95~=1));

replace expbad=1 if exper96-exper94~=2 & exper94~=. & exper96~=. & (exper95~=. |
(exper95==. & exper96-exper94~=1));

replace expbad=1 if exper95-exper93~=2 & exper93~=. & exper95~=. & (exper94~=. | 
(exper94==. & exper95-exper93~=1));

replace expbad=1 if exper98-exper95~=3 & exper95~=. & exper98~=. & ((exper96~=. &
exper97~=.) | (exper96==. & exper97==. & exper98-exper95~=1) |
(exper96~=. & exper97==. & exper98-exper95~=2) |  (exper96==. & exper97~=. &
exper98-exper95~=2));

replace expbad=1 if exper97-exper94~=3 & exper94~=. & exper97~=. & ((exper95~=. &
exper96~=.) | (exper95==. & exper96==. & exper97-exper94~=1) |
(exper95~=. & exper96==. & exper97-exper94~=2) |  (exper95==. & exper96~=. &
exper97-exper94~=2));

replace expbad=1 if exper96-exper93~=3 & exper93~=. & exper96~=. & ((exper94~=. &
exper95~=.) | (exper94==. & exper95==. & exper96-exper93~=1) |
(exper94~=. & exper95==. & exper96-exper93~=2) |  (exper94==. & exper95~=. &
exper96-exper93~=2));

/**fix experience variables**/

gen byte aexper94=exper94;
gen byte aexper95=exper95;
gen byte aexper96=exper96;
gen byte aexper97=exper97;
gen byte aexper98=exper98;

replace aexper94=0 if exper94==1 & exper95==1 & exper96==2 & exper93==.;
replace aexper95=0 if exper95==1 & exper96==1 & exper97==2 & exper94==.;
replace aexper96=0 if exper96==1 & exper97==1 & exper98==2 & exper95==.;
replace aexper97=0 if exper97==1 & exper98==1 & exper96==.;

local yr 94;
while `yr'<=96 {;


	local yrm2=`yr'-2;
	local yrm1=`yr'-1;
	local yr1=`yr'+1;
	local yr2=`yr'+2;

	di "fix exper`yr'";

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr1'-exper`yr'~=1 &
	exper`yr'-exper`yrm1'~=1 & exper`yr1'-exper`yrm1'==2 & exper`yr'~=. & exper`yr1'~=.;

	replace aexper`yr'=exper`yr2'-2 if expbad==1 & exper`yr1'-exper`yr'~=1 &
	exper`yr2'-exper`yrm1'==3 & exper`yr1'-exper`yrm1'~=2 & exper`yr'~=. & exper`yr1'~=. &
	exper`yr2'~=.;

	replace aexper`yr'=exper`yr2'-1 if expbad==1 & exper`yr2'-exper`yrm1'==2 &
	exper`yr1'==. & exper`yr'-exper`yrm1'~=1 & exper`yr2'~=.;

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr1'-exper`yrm2'==3 &
	exper`yr1'-exper`yrm1'~=2 & (exper`yr2'-exper`yrm1'~=3 | exper`yr2'==.) & 
	exper`yr'~=. & exper94-exper93~=1 & exper95-exper94~=1 & exper95~=.;

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr1'-exper`yrm2'==2 & 
	exper`yrm1'==. & exper`yr'~=. & exper`yr1'-exper`yr'~=1 & exper`yr1'~=.;

	replace aexper`yr'=exper`yr2'-2 if expbad==1 & exper`yr2'-exper`yrm2'==4 & 
	exper`yr1'-exper`yrm1'~=2 & exper`yr2'-exper`yrm1'~=3 & exper`yr1'-exper`yrm2'~=3 & 
	exper`yr'~=. & exper`yrm1'~=. & exper`yr1'-exper`yr'~=1 & exper`yr1'~=. & 
	exper`yr'-exper`yrm1'~=1 & exper`yr2'~=.;

	replace aexper`yr'=exper`yr2'-1 if expbad==1 & exper`yr2'-exper`yrm2'==3 & 
	exper`yr'~=. & exper`yrm1'~=. & exper`yr'-exper`yrm1'~=1 & exper`yr1'==. & exper`yr2'~=.;

	replace aexper`yr'=exper`yr2'-1 if expbad==1 & exper`yr2'-exper`yrm2'==2 & 
	exper`yr'~=. & exper`yrm1'==. & exper`yr1'==. & exper`yr2'~=.;

	replace aexper`yr'=exper`yrm1'+1 if expbad==1 & exper`yrm1'-exper`yrm2'==1 & 
	exper`yr'~=. & exper`yrm1'~=.;

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr2'-exper`yr1'==1 & 
	exper`yr'~=. & exper`yr1'~=.;

	local yr = `yr' + 1;
	};



local yr 97;
while `yr'<=97 {;

	local yrm3=`yr'-3;
	local yrm2=`yr'-2;
	local yrm1=`yr'-1;
	local yr1=`yr'+1;

	di "fix exper`yr'";

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr1'-exper`yr'~=1 & exper`yr1'-exper`yrm1'==2 &
	exper`yr'~=. & exper`yr1'~=.;

	replace aexper`yr'=exper`yrm1'+1 if expbad==1 & (exper`yr1'==. | exper`yr1'-exper`yr'~=1) &
	exper`yrm1'-exper`yrm2'==1 & (exper`yr1'==. | exper`yr1'-exper`yrm1'~=2) & exper`yr'~=. & exper`yrm1'~=.;

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr1'-exper`yr'~=1  & exper`yr1'-exper`yrm1'~=2 &
	exper`yrm1'~=. & exper`yr1'-exper`yrm1'==3 & exper`yr'~=. & exper`yr1'~=.;

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr1'-exper`yr'~=1 & exper`yrm1'==. &
	exper`yr1'-exper`yrm2'==2 & exper`yr'~=. & exper`yr1'~=.;

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr1'-exper`yrm3'==4 & exper`yrm2'~=. & exper`yrm1'~=. &
	exper`yr'~=. & exper`yr1'~=.;

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr1'-exper`yrm3'==3 & (exper`yrm1'==. | exper`yrm2'==.) &
	exper`yr'~=. & (exper`yr'-exper`yrm1'~=1 | exper`yrm1'==.) & exper`yr1'~=.;

	replace aexper`yr'=exper`yr1'-1 if expbad==1 & exper`yr1'-exper`yrm3'==2 & exper`yrm1'==. & exper`yrm2'==. &
	exper`yr'~=. & exper`yr1'~=.;

	replace aexper`yr'=exper`yrm1'+1 if expbad==1 & exper`yrm1'-exper`yrm2'==1 & (exper`yr1'-exper`yr' ~=1 |
	exper`yr1'==.) & exper`yr'~=. & exper`yrm1'~=.;

	replace aexper`yr'=exper`yrm1'+1 if expbad==1 & exper`yrm1'-exper`yrm3'==2 & (exper`yr1'-exper`yr'~=1 |
	exper`yr1'==.) & exper`yr'~=. & exper`yrm2'~=. & exper`yrm1'~=.;

	replace aexper`yr'=exper`yrm1'+1 if expbad==1 & exper`yrm1'-exper`yrm3'==1 & (exper`yr1'-exper`yr'~=1 |
	exper`yr1'==.) & exper`yr'~=. & exper`yrm2'==. & exper`yrm1'~=.;

	replace aexper`yr'=exper`yrm2'+2 if expbad==1 & (exper`yr1'-exper`yr'~=1 | exper`yr1'==.) &
	(exper`yr1'-exper`yrm1'~=2 | exper`yr1'==.) & exper`yr'-exper`yrm1'~=1 & exper`yrm2'-exper`yrm3'==1 &
	exper`yr'~=. & exper`yrm1'~=. & exper`yrm2'~=.;

	local yr = `yr'+1;
	};

di "fix exper98";

replace aexper98=exper97+1 if expbad==1 & exper98-exper97~=1 & exper97-exper96==1 &
exper98~=. & exper97~=.;

replace aexper98=exper97+1 if expbad==1 & exper98-exper97~=1 & exper97-exper95==2 &
exper98~=. & exper98-exper96~=2 & exper96~=. & exper97~=.;

replace aexper98=exper97+1 if expbad==1 & exper98-exper97~=1 & exper97-exper95==1 &
exper98~=. & exper96==. & exper97~=.;

replace aexper98=exper97+1 if expbad==1 & exper98-exper97~=1 & exper97-exper94==3 &
exper98~=. & exper96~=. & exper95~=. & exper98-exper96~=2 & exper98-exper95~=3 &
exper97~=.;

replace aexper98=exper97+1 if expbad==1 & exper98-exper97~=1 & exper97-exper94==2 &
exper98~=. & (exper96==. | exper95==.) & (exper98-exper96~=2 | exper96==.) &
(exper98-exper95~=3 | exper95==.) & exper97~=.;

replace aexper98=exper97+1 if expbad==1 & exper98-exper97~=1 & exper97-exper94==1 &
exper98~=. & exper96==. & exper95==. & exper97~=.;

replace aexper98=exper96+2 if expbad==1 & exper97~=. & exper98-exper97~=1 & exper98~=.
& exper96~=.;

replace aexper98=exper96+1 if expbad==1 & exper97==. & exper98-exper96~=2 & exper98~=.
& exper96~=.;

replace aexper98=exper95+3 if expbad==1 & exper97~=. & exper96~=. & exper98-exper97~=1
& exper98-exper96~=2 & exper98-exper95~=3 & exper95-exper94==1 & exper95~=. &
exper98~=.;

replace aexper98=exper95+3 if expbad==1 & exper97~=. & exper96~=. & exper98-exper97~=1
& exper98-exper96~=2 & exper98-exper95~=3 & exper95-exper94==1 & exper95~=. &
exper98~=.;

replace aexper98=exper95+2 if expbad==1 & exper97==. & exper96~=. & exper98-exper96~=2
& exper98-exper95~=3 & exper95-exper94==1 & exper95~=. & exper98~=.;

replace aexper98=exper95+2 if expbad==1 & exper97~=. & exper96==. & exper98-exper97~=1
& exper98-exper95~=3 & exper95-exper94==1 & exper95~=. & exper98~=.;

replace aexper98=exper95+1 if expbad==1 & exper97==. & exper96==. & exper98-exper95~=3
& exper95-exper94==1 & exper95~=. & exper98~=.;

#delimit cr


gen byte expbad2=0
replace expbad2=1 if aexper94-exper93~=1 & exper93~=. & aexper94~=.
replace expbad2=1 if aexper95-aexper94~=1 & aexper94~=. & aexper95~=.
replace expbad2=1 if aexper96-aexper95~=1 & aexper95~=. & aexper96~=.
replace expbad2=1 if aexper97-aexper96~=1 & aexper96~=. & aexper97~=.
replace expbad2=1 if aexper98-aexper97~=1 & aexper97~=. & aexper98~=.


#delimit ;
replace expbad2=1 if aexper98-aexper96~=2 & aexper96~=. & aexper98~=. & (aexper97~=. |
(aexper97==. & aexper98-aexper96~=1));

replace expbad2=1 if aexper97-aexper95~=2 & aexper95~=. & aexper97~=. & (aexper96~=. |
(aexper96==. & aexper97-aexper95~=1));

replace expbad2=1 if aexper96-aexper94~=2 & aexper94~=. & aexper96~=. & (aexper95~=. |
(aexper95==. & aexper96-aexper94~=1));

replace expbad2=1 if aexper95-exper93~=2 & exper93~=. & aexper95~=. & (aexper94~=. | 
(aexper94==. & aexper95-exper93~=1));

replace expbad2=1 if aexper98-exper95~=3 & exper95~=. & aexper98~=. & ((aexper96~=. &
aexper97~=.) | (aexper96==. & aexper97==. & aexper98-exper95~=1) |
(aexper96~=. & aexper97==. & aexper98-exper95~=2) |  (aexper96==. & aexper97~=. &
aexper98-exper95~=2));

replace expbad2=1 if aexper97-exper94~=3 & exper94~=. & aexper97~=. & ((aexper95~=. &
aexper96~=.) | (aexper95==. & aexper96==. & aexper97-exper94~=1) |
(aexper95~=. & aexper96==. & aexper97-exper94~=2) |  (aexper95==. & aexper96~=. &
aexper97-exper94~=2));

replace expbad2=1 if aexper96-exper93~=3 & exper93~=. & aexper96~=. & ((aexper94~=. &
aexper95~=.) | (aexper94==. & aexper95==. & aexper96-exper93~=1) |
(aexper94~=. & aexper95==. & aexper96-exper93~=2) |  (aexper94==. & aexper95~=. &
aexper96-exper93~=2));

#delimit cr

tab expbad expbad2

/**drop fix if fixed experience<0**/

replace aexper94=exper94 if aexper94<0
replace aexper95=exper95 if aexper95<0
replace aexper96=exper96 if aexper96<0
replace aexper97=exper97 if aexper97<0
replace aexper98=exper98 if aexper98<0

drop exper94 exper95 exper96 exper97 exper98
rename aexper94 exper94
rename aexper95 exper95
rename aexper96 exper96
rename aexper97 exper97
rename aexper98 exper98

save ${rivkin_home}simba_e/texdata/Texas/teacher/masttea2, replace
