/**this file creates a file to run fixed effects regressions and runs individual fixed effects.**/

capture program drop ifixeffr
program define ifixeffr

set memory 400m
set more off
cap log close

tempfile tempdat temp495 temp594 temp595 temp596 temp695 temp696 temp697 temp796 temp797
log using ${rivkin_home}simba_e/Texas/quality/RESULTS/ifixeffr.log,replace

tempfile tempdat

di "creating file for 495"
use rivid disad495 srgai495 stdre495 spec495 bil495 /*
*/ pzex495 poex495 ptex495 ptfex495 pfnex495 ptwex495 numt495 stud495 /*
*/ camp495 pmas495 same495 /*
*/ sex black asian hisp lcity scity sub using ${rivkin_home}simba_e/texdata/Texas/quality/rstea495 
sort rivid

drop if stud495>25

di "dropping bilingual and special ed kid"
drop if spec495==1 | bil495==1
drop spec495 bil495

di "creating grade/cohort dummies"

gen int year=495
gen byte grade=4


gen byte year594=0
gen byte year595=0
gen byte year596=0
gen byte year695=0
gen byte year696=0
gen byte year697=0
gen byte year796=0
gen byte year797=0

di "renaming variables"
rename srgai495 srgai
rename stdre495 stdre
rename camp495 camp
rename disad495 disad
rename stud495 stud
rename pzex495 pzex
rename poex495 poex
rename ptex495 ptex
rename ptfex495 ptfex
rename pfnex495 pfnex
rename ptwex495 ptwex
rename numt495 numt
rename pmas495 pmas
rename same495 same
rename black495 black
rename hisp495 hisp
rename asian495 asian
rename lcity495 lcity
rename scity495 scity
rename sub495 sub

di "creating stud interactions"
gen stud4=stud
gen stud5=0
gen stud6=0
gen stud7=0

di "creating experience interactions"
gen pzex4=pzex
gen poex4=poex
gen pzex5=0
gen poex5=0
gen pzex6=0
gen poex6=0
gen pzex7=0
gen poex7=0

save `temp495'


di "creating file for 695"
use rivid disad695 srgai695 stdre695/*
*/ spec695 bil695 pzex695 poex695 ptex695 ptfex695 pfnex695 ptwex695 numt695 /*
*/ stud695 camp695 pmas695 same695 /*
*/ sex black asian hisp lcity scity sub  using ${rivkin_home}simba_e/texdata/Texas/quality/rstea695 
sort rivid

drop if spec695==1 | bil695==1
drop spec695 bil695

di "create grade/cohort dummies"
gen byte grade=6
gen int year=695

gen byte year594=0
gen byte year595=0
gen byte year596=0
gen byte year695=1
gen byte year696=0
gen byte year697=0
gen byte year796=0
gen byte year797=0

rename camp695 camp
rename stdre695 stdre
rename srgai695 srgai
rename disad695 disad
rename stud695 stud
rename pzex695 pzex
rename poex695 poex
rename ptex695 ptex
rename ptfex695 ptfex
rename pfnex695 pfnex
rename ptwex695 ptwex
rename numt695 numt
rename pmas695 pmas
rename same695 same
rename black695 black
rename hisp695 hisp
rename asian695 asian
rename lcity695 lcity
rename scity695 scity
rename sub695 sub

gen stud4=0
gen stud5=0
gen stud6=stud
gen stud7=0

gen pzex4=0
gen poex4=0
gen pzex5=0
gen poex5=0
gen pzex6=pzex
gen poex6=poex
gen pzex7=0
gen poex7=0

save `temp695'

di "creating file for 696"
use rivid disad696 srgai696 stdre696 spec696 bil696 /*
*/ pzex696 poex696 ptex696 ptfex696 pfnex696 ptwex696 numt696 /*
*/ stud696 camp696 pmas696 same696 /*
*/ sex black asian hisp lcity scity sub  using ${rivkin_home}simba_e/texdata/Texas/quality/rstea696 
sort rivid

drop if spec696==1 | bil696==1
drop spec696 bil696

di "create grade/cohort dummies"
gen byte grade=6
gen int year=696

gen byte year594=0
gen byte year595=0
gen byte year596=0
gen byte year695=0
gen byte year696=1
gen byte year697=0
gen byte year796=0
gen byte year797=0

rename camp696 camp
rename srgai696 srgai
rename stdre696 stdre
rename disad696 disad
rename stud696 stud
rename pzex696 pzex
rename poex696 poex
rename ptex696 ptex
rename ptfex696 ptfex
rename pfnex696 pfnex
rename ptwex696 ptwex
rename numt696 numt
rename pmas696 pmas
rename same696 same
rename black696 black
rename hisp696 hisp
rename asian696 asian
rename lcity696 lcity
rename scity696 scity
rename sub696 sub

gen stud4=0
gen stud5=0
gen stud6=stud
gen stud7=0

gen pzex4=0
gen poex4=0
gen pzex5=0
gen poex5=0
gen pzex6=pzex
gen poex6=poex
gen pzex7=0
gen poex7=0

save `temp696'

di "creating file for 697"
use rivid disad697 srgai697 stdre697 spec697 bil697 /*
*/ pzex697 poex697 ptex697 ptfex697 pfnex697 ptwex697 numt697 /*
*/ stud697 camp697 pmas697 same697 /*
*/ sex black asian hisp lcity scity sub  using ${rivkin_home}simba_e/texdata/Texas/quality/rstea697 

drop if spec697==1 | bil697==1
drop spec697 bil697

di "create grade/cohort dummies"
gen byte grade=6
gen int year=697

gen byte year594=0
gen byte year595=0
gen byte year596=0
gen byte year695=0
gen byte year696=0
gen byte year697=1
gen byte year796=0
gen byte year797=0


rename camp697 camp
rename srgai697 srgai
rename stdre697 stdre
rename disad697 disad
rename stud697 stud
rename pzex697 pzex
rename poex697 poex
rename ptex697 ptex
rename ptfex697 ptfex
rename pfnex697 pfnex
rename ptwex697 ptwex
rename numt697 numt
rename pmas697 pmas
rename same697 same
rename black697 black
rename hisp697 hisp
rename asian697 asian
rename lcity697 lcity
rename scity697 scity
rename sub697 sub

gen stud4=0
gen stud5=0
gen stud6=stud
gen stud7=0

gen pzex4=0
gen poex4=0
gen pzex5=0
gen poex5=0
gen pzex6=pzex
gen poex6=poex
gen pzex7=0
gen poex7=0

save `temp697'


di "creating files for grade 5 data"
local daloop = 594
while `daloop'<=596 {

     di "creating file for `daloop'"
     use rivid disad`daloop' srgai`daloop' stdre`daloop' spec`daloop' bil`daloop' pzex`daloop'  sex black asian hisp /*
     */ lcity scity sub same`daloop' /*
     */ poex`daloop'  ptex`daloop' ptfex`daloop' pfnex`daloop' ptwex`daloop' numt`daloop' /*
     */ stud`daloop' camp`daloop' pmas`daloop' using ${rivkin_home}simba_e/texdata/Texas/quality/rstea`daloop' 
     sort rivid

     drop if spec`daloop'==1 | bil`daloop'==1
     drop spec`daloop' bil`daloop'

     di "create grade/cohort dummies"
     gen byte grade=5
     gen int year=`daloop'

     gen byte year594=`daloop'==594
     gen byte year595=`daloop'==595
     gen byte year596=`daloop'==596
     gen byte year695=0
     gen byte year696=0
     gen byte year697=0
     gen byte year796=0
     gen byte year797=0

     rename camp`daloop' camp
     rename srgai`daloop' srgai
     rename stdre`daloop' stdre
     rename disad`daloop' disad
     rename stud`daloop' stud
     rename pzex`daloop' pzex
     rename poex`daloop' poex
     rename ptex`daloop' ptex
     rename ptfex`daloop' ptfex
     rename pfnex`daloop' pfnex
     rename ptwex`daloop' ptwex
     rename numt`daloop' numt
     rename pmas`daloop' pmas
     rename same`daloop' same
     rename black`daloop' black
     rename hisp`daloop' hisp
     rename asian`daloop' asian
     rename lcity`daloop' lcity
     rename scity`daloop' scity
     rename sub`daloop' sub


     gen stud4=0
     gen stud5=stud
     gen stud6=0
     gen stud7=0

     gen pzex4=0
     gen poex4=0
     gen pzex5=pzex
     gen poex5=poex
     gen pzex6=0
     gen poex6=0
     gen pzex7=0
     gen poex7=0

     save `temp`daloop''

     local daloop = `daloop' + 1

     }

di "creating files for grade 7 data"
local daloop = 796
while `daloop'<=797 {

     di "creating file for `daloop'"
     use rivid disad`daloop' srgai`daloop' stdre`daloop' spec`daloop' bil`daloop' pzex`daloop'  sex black asian hisp /*
     */ lcity scity sub same`daloop' /*
     */ poex`daloop' ptex`daloop' ptfex`daloop' pfnex`daloop' ptwex`daloop' numt`daloop' /*
     */ stud`daloop' camp`daloop' pmas`daloop' using ${rivkin_home}simba_e/texdata/Texas/quality/rstea`daloop' 
     sort rivid

     drop if spec`daloop'==1 | bil`daloop'==1
     drop spec`daloop' bil`daloop'

     di "create grade/cohort dummies"
     gen byte grade=7
     gen int year=`daloop'

     gen byte year594=0
     gen byte year595=0
     gen byte year596=0
     gen byte year695=0
     gen byte year696=0
     gen byte year697=0
     gen byte year796=`daloop'==796
     gen byte year797=`daloop'==797

     rename camp`daloop' camp
     rename srgai`daloop' srgai
     rename stdre`daloop' stdre
     rename disad`daloop' disad
     rename stud`daloop' stud
     rename pzex`daloop' pzex
     rename poex`daloop' poex
     rename ptex`daloop' ptex
     rename ptfex`daloop' ptfex
     rename pfnex`daloop' pfnex
     rename ptwex`daloop' ptwex
     rename numt`daloop' numt
     rename pmas`daloop' pmas
     rename same`daloop' same
     rename black`daloop' black
     rename hisp`daloop' hisp
     rename asian`daloop' asian
     rename lcity`daloop' lcity
     rename scity`daloop' scity
     rename sub`daloop' sub


     gen stud4=0
     gen stud5=0
     gen stud6=0
     gen stud7=stud

     gen pzex4=0
     gen poex4=0
     gen pzex5=0
     gen poex5=0
     gen pzex6=0
     gen poex6=0
     gen pzex7=pzex
     gen poex7=poex

     save `temp`daloop''

     local daloop = `daloop' + 1

     }

di "using 495"
use `temp495'
sum srgai

di "appending data for 594"
append using `temp594'
sum srgai

di "appending data for 595"
append using `temp595'
sum srgai

di "appending data for 596"
append using `temp596'
sum srgai

di "appending data for 695"
append using `temp695'
sum srgai

di "appending data for 696"
append using `temp696'
sum srgai

di "appending data for 697"
append using `temp697'
sum srgai

di "appending data for 796"
append using `temp796'
sum srgai

di "appending data for 797"
append using `temp797'
sum srgai

drop if pzex==. | poex==. | stud==. | pmas==. | disad==. | srgai==. | same==. | sex==. | black==. | hisp==. | asian==. | lcity==. | /*
*/ scity==. | sub==.

sort rivid
quietly by rivid: gen numobs=_N
tab numobs
quietly by rivid: keep if _N>=2


sort camp year
save `tempdat'

di "create campyr variable"
keep camp year
sort camp year
quietly by camp year: keep if _n==1
sort camp year
gen campyr=_n
sort camp year

list in 1/10

merge camp year using `tempdat'
tab _m
drop _m

di "make disad binary variable"
replace disad=1 if disad==2 | disad==9

tab sex year

di "ols regression"
regress srgai pmas pzex poex ptex ptfex stud sex black disad hisp asian lcity scity sub same /*
*/            year594 year595 year596 year695 year696 year697 year796 year797,  robust cluster(camp)

regress srgai pmas pzex poex ptex ptfex stud4 stud5 stud6 stud7 year594 year595 /*
*/ year596 year695 year696 year697 year796 year797 sex black disad hisp asian lcity scity sub same, robust cluster(camp)

sort grade
by grade: sum if srgai~=. & pmas~=. & pzex~=. & stud~=. & disad~=. & hisp~=. & asian~=. & black~=. & same~=.

di "fixed effect regression, no interaction"
areg srgai disad same pzex poex ptex ptfex stud pmas year594 year595 year596 year695 year696 year697 year796 year797, /*
*/ absorb(rivid) robust cluster(camp)

di "fixed effect regression, grade interaction"
areg srgai disad same pzex poex ptex ptfex stud4 stud5 stud6 stud7 pmas /*
*/ year594 year595 year596 year695 year696 year697 year796 year797, absorb(rivid) robust cluster(camp)

drop numobs
save ${rivkin_home}simba_e/texdata/Texas/quality/studwkr,replace

end
