/**this file creates a master data set for principals and superintendents**/

capture program drop suprinc
program define suprinc

set more off
cap log close
log using ${rivkin_home}simba_e/Texas/quality/RESULTS/suprinc.log,replace

tempfile temd193 temd194 temd195 temd196 temd197 temd198
tempfile temc193 temc194 temc195 temc196 temc197 temc198

local daloop=193
while `daloop' <=198 {

     di "using noncla`daloop'"
     use PID role campus using $hb_data/TEA/PEIMS/nonclasu/Data/nonclasu`daloop' if role==27

     gen dist=campus/1000
     gen long district=int(dist)
     drop dist

     gen supid`daloop'=real(PID)
     drop role PID

     #delimit ;
     collapse supid`daloop' (max) maxsid`daloop'=supid`daloop' (min) 
     minsid`daloop'=supid`daloop',by(district);
     #delimit cr

     list if minsid`daloop'~=maxsid`daloop'
     drop maxsid`daloop' minsid`daloop'
     sort district
     save `temd`daloop''

     di "using noncla`daloop'"

     use PID role campus using $hb_data/TEA/PEIMS/nonclasu/Data/nonclasu`daloop' if role==20

     gen dist=campus/1000
     gen long district=int(dist)
     drop dist

     gen prid`daloop'=real(PID)
     drop role PID

     #delimit ;
     collapse district prid`daloop' (max) maxpid`daloop'=prid`daloop' (min)
     minpid`daloop'=prid`daloop',by(campus);
     #delimit cr

     list if minpid`daloop'~=maxpid`daloop'
     drop maxpid`daloop' minpid`daloop'
     sort district

     merge district using `temd`daloop''
     tab _m
     keep if _m==3
     drop _m
     sort campus
     quietly by campus: gen num=_N
     tab num
     list if num~=1
     drop num
     sort campus
     save `temc`daloop''

     local daloop = `daloop' + 1
}

/**merging data from different years**/
use `temc193'
local mrgloop = 194
while `mrgloop'<=198 {

     di "merging data `mrgloop' "

     merge campus using `temc`mrgloop''
     tab _merge
     drop _m
     sort campus

     local mrgloop=`mrgloop' + 1
}

di "creating indicators for new principals and supers"
gen byte newpr94=prid194~=prid193
gen byte newpr95=prid195~=prid194
gen byte newpr96=prid196~=prid195
gen byte newpr97=prid197~=prid196
gen byte newpr98=prid198~=prid197

gen byte newsup94=supid194~=supid193
gen byte newsup95=supid195~=supid194
gen byte newsup96=supid196~=supid195
gen byte newsup97=supid197~=supid196
gen byte newsup98=supid198~=supid197

keep campus new*

sort campus
save ${rivkin_home}simba_e/texdata/Texas/teacher/suprinc,replace

sum
end
