/**this file creates a data set with student and teacher data for use in education production
function regressions. Only data for regular classrooms are used.*/

set more off
cap log close
log using ${rivkin_home}simba_e/Texas/quality/RESULTS/teavar2ss.log,replace

/**create teacher data sets for each year/grade. Four data sets are created 1) all math and general teachers;
2) all english and general teachers; 3) math teachers; and 4) english teachers.**/

di "create data sets for all math and general teachers"
local grloop = 3
while `grloop'<=7 {

     local yrloop=93
     while `yrloop' <=98 {

          di "using data for `grloop'th grade in `yrloop'"
          use ${rivkin_home}simba_e/texdata/Texas/teacher/tbycgss
          keep if grade==`grloop' & year==`yrloop'

	  di "rename variables"
          rename pmas pmas`grloop'`yrloop'
          rename pzex pzex`grloop'`yrloop'
          rename poex poex`grloop'`yrloop'
          rename ptex ptex`grloop'`yrloop'
          rename ptfex ptfex`grloop'`yrloop'
          rename pfnex pfnex`grloop'`yrloop'
          rename ptwex ptwex`grloop'`yrloop'
          rename pthex pthex`grloop'`yrloop'
          rename campus camp`grloop'`yrloop'
          rename exper exper`grloop'`yrloop'
          rename stud stud`grloop'`yrloop'
          rename numtea numt`grloop'`yrloop'

          #delimit ;
          keep camp`grloop'`yrloop' exper`grloop'`yrloop' stud`grloop'`yrloop'
          pmas`grloop'`yrloop' pzex`grloop'`yrloop' numt`grloop'`yrloop'
          poex`grloop'`yrloop' ptex`grloop'`yrloop' ptfex`grloop'`yrloop'
          pfnex`grloop'`yrloop' ptwex`grloop'`yrloop' pthex`grloop'`yrloop' ;

          #delimit cr

          sort camp`grloop'`yrloop'
	  quietly by camp`grloop'`yrloop': assert _N==1

          save ${rivkin_home}simba_e/texdata/Texas/teacher/alltss`grloop'`yrloop',replace
	  clear

          local yrloop = `yrloop' + 1
     }

     local grloop = `grloop' + 1
}

di "create data sets for all english and general teachers"
local grloop = 3
while `grloop'<=7 {

     local yrloop=93
     while `yrloop' <=98 {

          di "using data for `grloop'th grade in `yrloop'"
          use ${rivkin_home}simba_e/texdata/Texas/teacher/rtbycgss
          keep if grade==`grloop' & year==`yrloop'

	  di "rename variables"
          rename pmas pmas`grloop'`yrloop'
          rename pzex pzex`grloop'`yrloop'
          rename poex poex`grloop'`yrloop'
          rename ptex ptex`grloop'`yrloop'
          rename ptfex ptfex`grloop'`yrloop'
          rename pfnex pfnex`grloop'`yrloop'
          rename ptwex ptwex`grloop'`yrloop'
          rename pthex pthex`grloop'`yrloop'
          rename campus camp`grloop'`yrloop'
          rename exper exper`grloop'`yrloop'
          rename stud stud`grloop'`yrloop'
          rename numtea numt`grloop'`yrloop'

          #delimit ;
          keep camp`grloop'`yrloop' exper`grloop'`yrloop' stud`grloop'`yrloop'
          pmas`grloop'`yrloop' pzex`grloop'`yrloop' numt`grloop'`yrloop'
          poex`grloop'`yrloop' ptex`grloop'`yrloop' ptfex`grloop'`yrloop'
          pfnex`grloop'`yrloop' ptwex`grloop'`yrloop' pthex`grloop'`yrloop' ;

          #delimit cr

          sort camp`grloop'`yrloop'
	  quietly by camp`grloop'`yrloop': assert _N==1

          save ${rivkin_home}simba_e/texdata/Texas/teacher/ralltss`grloop'`yrloop',replace
	  clear

          local yrloop = `yrloop' + 1
     }

     local grloop = `grloop' + 1
}

